#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK68x4x68NN2x4x1_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=68, NB=4, KB=68, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=4, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 68;
   const float *stN = B + (((ldb) << 2));
   const float *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 2 - (((lda) << 6)+((lda) << 2)), incAn = -68;
   #define incBk 1
   const int incBm = -68, incBn = (((ldb) << 2));
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 2)) - 68;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register float rA0, rA1;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   do /* M-loop */
   {
      rC0_0 = *pC0;
      rC1_0 = pC0[1];
      rC0_1 = *pC1;
      rC1_1 = pC1[1];
      rC0_2 = *pC2;
      rC1_2 = pC2[1];
      rC0_3 = *pC3;
      rC1_3 = pC3[1];
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[1];
      rB1 = *pB1;
      rB2 = *pB2;
      m0 = rA0 * rB0;
      rB3 = *pB3;
      m1 = rA1 * rB0;
      m2 = rA0 * rB1;
      m3 = rA1 * rB1;
      m4 = rA0 * rB2;
      m5 = rA1 * rB2;
      m6 = rA0 * rB3;
      m7 = rA1 * rB3;
      pA0 += incAk0;
      rA0 = *pA0;
      rB0 = pB0[1];
      rA1 = pA0[1];
      rB1 = pB1[1];
      rB2 = pB2[1];
      rB3 = pB3[1];

      pB0 += (incBk0);
      pB1 += (incBk0);
      pB2 += (incBk0);
      pB3 += (incBk0);
      for (k=66; k; k--) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         rA1 = pA0[1];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rB3 = pB3[1];
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
      } /* end K-loop */
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      rC0_2 += m4;
      m4 = rA0 * rB2;
      rC1_2 += m5;
      m5 = rA1 * rB2;
      rC0_3 += m6;
      m6 = rA0 * rB3;
      rC1_3 += m7;
      m7 = rA1 * rB3;
      pA0 += incAk0;
      rC0_0 += m0;
      rC1_0 += m1;
      rC0_1 += m2;
      rC1_1 += m3;
      rC0_2 += m4;
      rC1_2 += m5;
      rC0_3 += m6;
      rC1_3 += m7;
      pB0 += incBk0;
      pB1 += incBk0;
      pB2 += incBk0;
      pB3 += incBk0;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK68x68x68NN0x0x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=68, NB=68, KB=68, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=8, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 68;
   const float *stN = B + (((ldb) << 6));
   const float *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 2 - (((lda) << 6)+((lda) << 2)), incAn = -68;
   #define incBk 1
   const int incBm = -68, incBn = (((ldb) << 3));
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)) - 68;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc);
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb), *pB5=pB4+(ldb), *pB6=pB5+(ldb), *pB7=pB6+(ldb);
   register int k;
   register float rA0, rA1;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5, rC0_6, rC1_6, rC0_7, rC1_7;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = *pC0;
         rC1_0 = pC0[1];
         rC0_1 = *pC1;
         rC1_1 = pC1[1];
         rC0_2 = *pC2;
         rC1_2 = pC2[1];
         rC0_3 = *pC3;
         rC1_3 = pC3[1];
         rC0_4 = *pC4;
         rC1_4 = pC4[1];
         rC0_5 = *pC5;
         rC1_5 = pC5[1];
         rC0_6 = *pC6;
         rC1_6 = pC6[1];
         rC0_7 = *pC7;
         rC1_7 = pC7[1];
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rB1 = *pB1;
         rB2 = *pB2;
         m0 = rA0 * rB0;
         rB3 = *pB3;
         rB4 = *pB4;
         rB5 = *pB5;
         rB6 = *pB6;
         rB7 = *pB7;
         m1 = rA1 * rB0;
         m2 = rA0 * rB1;
         m3 = rA1 * rB1;
         m4 = rA0 * rB2;
         m5 = rA1 * rB2;
         m6 = rA0 * rB3;
         m7 = rA1 * rB3;

         for (k=67; k; k--) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB4;
            rC1_0 += m1;
            m1 = rA1 * rB4;
            rC0_1 += m2;
            m2 = rA0 * rB5;
            rC1_1 += m3;
            m3 = rA1 * rB5;
            rC0_2 += m4;
            m4 = rA0 * rB6;
            rC1_2 += m5;
            m5 = rA1 * rB6;
            rC0_3 += m6;
            m6 = rA0 * rB7;
            rC1_3 += m7;
            m7 = rA1 * rB7;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rA1 = pA0[1];
            rB1 = pB1[1];
            rB2 = pB2[1];
            rB3 = pB3[1];
            rB4 = pB4[1];
            rB5 = pB5[1];
            rB6 = pB6[1];
            rB7 = pB7[1];
            rC0_4 += m0;
            m0 = rA0 * rB0;
            rC1_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA0 * rB1;
            rC1_5 += m3;
            m3 = rA1 * rB1;
            rC0_6 += m4;
            m4 = rA0 * rB2;
            rC1_6 += m5;
            m5 = rA1 * rB2;
            rC0_7 += m6;
            m6 = rA0 * rB3;
            rC1_7 += m7;
            m7 = rA1 * rB3;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
            pB4 += incBk;
            pB5 += incBk;
            pB6 += incBk;
            pB7 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB4;
         rC1_0 += m1;
         m1 = rA1 * rB4;
         rC0_1 += m2;
         m2 = rA0 * rB5;
         rC1_1 += m3;
         m3 = rA1 * rB5;
         rC0_2 += m4;
         m4 = rA0 * rB6;
         rC1_2 += m5;
         m5 = rA1 * rB6;
         rC0_3 += m6;
         m6 = rA0 * rB7;
         rC1_3 += m7;
         m7 = rA1 * rB7;
         pA0 += incAk0;
         rC0_4 += m0;
         rC1_4 += m1;
         rC0_5 += m2;
         rC1_5 += m3;
         rC0_6 += m4;
         rC1_6 += m5;
         rC0_7 += m6;
         rC1_7 += m7;
         pB0 += incBk0;
         pB1 += incBk0;
         pB2 += incBk0;
         pB3 += incBk0;
         pB4 += incBk0;
         pB5 += incBk0;
         pB6 += incBk0;
         pB7 += incBk0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         *pC5 = rC0_5;
         pC5[1] = rC1_5;
         *pC6 = rC0_6;
         pC6[1] = rC1_6;
         *pC7 = rC0_7;
         pC7[1] = rC1_7;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
         pB6 += incBm;
         pB7 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
      pB6 += incBn;
      pB7 += incBn;
   }
   while(pB0 != stN);
   ATL_sJIK68x4x68NN2x4x1_a1_b1(68, 4, 68, alpha, ca, lda, cb + (((ldb) << 6)), ldb, beta, cc + (((ldc) << 6)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
