#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x67TN1x1x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=67, 
 * lda=67, ldb=67, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (67*(Mb));
   const float *stN = B + (67*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(67*(Mb));
   #define incBk 1
   const int incBm = -67, incBn = 67;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

         pA0 += (incAk0);
         pB0 += (incBk0);
         for (k=65; k; k--) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_sJIK0x0x67TN2x1x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=67, 
 * lda=67, ldb=67, ldc=0, mu=2, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>1)<<1;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (67*(Mb));
   const float *stN = B + (67*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 67, incAn = -(67*(Mb));
   #define incBk 1
   const int incBm = -67, incBn = 67;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0;
   register float m0, m1;
   register float rC0_0, rC1_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[67];
            m0 = rA0 * rB0;
            m1 = rA1 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[68];

            pA0 += (incAk0);
            pB0 += (incBk0);
            for (k=65; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[68];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC0_0 += m0;
            rC1_0 += m1;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x67TN1x1x1_a1_bX(k, N, 67, alpha, ca + (67*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x67TN1x8x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=67, 
 * lda=67, ldb=67, ldc=0, mu=1, nu=8, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N>>3)<<3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (67*(Mb));
   const float *stN = B + (67*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*8)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(67*(Mb));
   #define incBk 1
   const int incBm = -67, incBn = 536;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (((ldc) << 3)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float m0, m1, m2, m3;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            rC0_6 = *pC6;
            rC0_6 *= rA0;
            rC0_7 = *pC7;
            rC0_7 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[67];
            m0 = rA0 * rB0;
            rB2 = pB0[134];
            rB3 = pB0[201];
            rB4 = pB0[268];
            m1 = rA0 * rB1;
            rB5 = pB0[335];
            rB6 = pB0[402];
            rB7 = pB0[469];
            m2 = rA0 * rB2;
            m3 = rA0 * rB3;

            for (k=66; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB4;
               rC0_1 += m1;
               m1 = rA0 * rB5;
               rC0_2 += m2;
               m2 = rA0 * rB6;
               rC0_3 += m3;
               m3 = rA0 * rB7;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[68];
               rB2 = pB0[135];
               rB3 = pB0[202];
               rB4 = pB0[269];
               rC0_4 += m0;
               m0 = rA0 * rB0;
               rB5 = pB0[336];
               rB6 = pB0[403];
               rB7 = pB0[470];
               rC0_5 += m1;
               m1 = rA0 * rB1;
               rC0_6 += m2;
               m2 = rA0 * rB2;
               rC0_7 += m3;
               m3 = rA0 * rB3;
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB4;
            rC0_1 += m1;
            m1 = rA0 * rB5;
            rC0_2 += m2;
            m2 = rA0 * rB6;
            rC0_3 += m3;
            m3 = rA0 * rB7;
            rC0_4 += m0;
            rC0_5 += m1;
            rC0_6 += m2;
            rC0_7 += m3;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            *pC6 = rC0_6;
            *pC7 = rC0_7;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_sJIK0x0x67TN1x1x1_a1_bX(M, k, 67, alpha, ca, lda, cb + (67*(Nb)), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x67TN67x67x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=67, 
 * lda=67, ldb=67, ldc=0, mu=2, nu=8, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>1)<<1;
   const int Nb = (N>>3)<<3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (67*(Mb));
   const float *stN = B + (67*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*8)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 67, incAn = -(67*(Mb));
   #define incBk 1
   const int incBm = -67, incBn = 536;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5, rC0_6, rC1_6, rC0_7, rC1_7;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            do /* M-loop */
            {
               ATL_pfl1R(pfA);
               pfA += incPFA;
               rA0 = beta;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[1];
               rC1_2 *= rA0;
               rC0_3 = *pC3;
               rC0_3 *= rA0;
               rC1_3 = pC3[1];
               rC1_3 *= rA0;
               rC0_4 = *pC4;
               rC0_4 *= rA0;
               rC1_4 = pC4[1];
               rC1_4 *= rA0;
               rC0_5 = *pC5;
               rC0_5 *= rA0;
               rC1_5 = pC5[1];
               rC1_5 *= rA0;
               rC0_6 = *pC6;
               rC0_6 *= rA0;
               rC1_6 = pC6[1];
               rC1_6 *= rA0;
               rC0_7 = *pC7;
               rC0_7 *= rA0;
               rC1_7 = pC7[1];
               rC1_7 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[67];
               m0 = rA0 * rB0;
               rB1 = pB0[67];
               rB2 = pB0[134];
               rB3 = pB0[201];
               m1 = rA1 * rB0;
               rB4 = pB0[268];
               rB5 = pB0[335];
               rB6 = pB0[402];
               m2 = rA0 * rB1;
               rB7 = pB0[469];
               m3 = rA1 * rB1;

               for (k=66; k; k--) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA0 * rB2;
                  rC1_0 += m1;
                  m1 = rA1 * rB2;
                  rC0_1 += m2;
                  m2 = rA0 * rB3;
                  rC1_1 += m3;
                  m3 = rA1 * rB3;
                  rC0_2 += m0;
                  m0 = rA0 * rB4;
                  rC1_2 += m1;
                  m1 = rA1 * rB4;
                  rC0_3 += m2;
                  m2 = rA0 * rB5;
                  rC1_3 += m3;
                  m3 = rA1 * rB5;
                  rC0_4 += m0;
                  m0 = rA0 * rB6;
                  rC1_4 += m1;
                  m1 = rA1 * rB6;
                  rC0_5 += m2;
                  m2 = rA0 * rB7;
                  rC1_5 += m3;
                  m3 = rA1 * rB7;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA0[68];
                  rB1 = pB0[68];
                  rB2 = pB0[135];
                  rB3 = pB0[202];
                  rC0_6 += m0;
                  m0 = rA0 * rB0;
                  rB4 = pB0[269];
                  rB5 = pB0[336];
                  rB6 = pB0[403];
                  rC1_6 += m1;
                  m1 = rA1 * rB0;
                  rB7 = pB0[470];
                  rC0_7 += m2;
                  m2 = rA0 * rB1;
                  rC1_7 += m3;
                  m3 = rA1 * rB1;
                  pA0 += incAk;
                  pB0 += incBk;
               } /* end K-loop */
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC1_0 += m1;
               m1 = rA1 * rB2;
               rC0_1 += m2;
               m2 = rA0 * rB3;
               rC1_1 += m3;
               m3 = rA1 * rB3;
               rC0_2 += m0;
               m0 = rA0 * rB4;
               rC1_2 += m1;
               m1 = rA1 * rB4;
               rC0_3 += m2;
               m2 = rA0 * rB5;
               rC1_3 += m3;
               m3 = rA1 * rB5;
               rC0_4 += m0;
               m0 = rA0 * rB6;
               rC1_4 += m1;
               m1 = rA1 * rB6;
               rC0_5 += m2;
               m2 = rA0 * rB7;
               rC1_5 += m3;
               m3 = rA1 * rB7;
               rC0_6 += m0;
               rC1_6 += m1;
               rC0_7 += m2;
               rC1_7 += m3;
               pA0 += incAk0;
               pB0 += incBk0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               *pC2 = rC0_2;
               pC2[1] = rC1_2;
               *pC3 = rC0_3;
               pC3[1] = rC1_3;
               *pC4 = rC0_4;
               pC4[1] = rC1_4;
               *pC5 = rC0_5;
               pC5[1] = rC1_5;
               *pC6 = rC0_6;
               pC6[1] = rC1_6;
               *pC7 = rC0_7;
               pC7[1] = rC1_7;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pC3 += incCm;
               pC4 += incCm;
               pC5 += incCm;
               pC6 += incCm;
               pC7 += incCm;
               pA0 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pC3 += incCn;
            pC4 += incCn;
            pC5 += incCn;
            pC6 += incCn;
            pC7 += incCn;
            pA0 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_sJIK0x0x67TN2x1x1_a1_bX(M, k, 67, alpha, ca, lda, cb + (67*(Nb)), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_sJIK0x0x67TN1x8x1_a1_bX(k, Nb, 67, alpha, ca + (67*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
